diff --git a/roms/ipxe/src/core/job.c b/roms/ipxe/src/core/job.c
index ac4e43e7bb590361b47f6f34e6b6..64d184ec313810735d1da11c932c 100644
--- a/roms/ipxe/src/core/job.c
+++ b/roms/ipxe/src/core/job.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/core/linebuf.c b/roms/ipxe/src/core/linebuf.c
index f152bccb0174f3d740bfa3975efa..8fb2f86a767c66419c8ef1f9b061 100644
--- a/roms/ipxe/src/core/linebuf.c
+++ b/roms/ipxe/src/core/linebuf.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/core/lineconsole.c b/roms/ipxe/src/core/lineconsole.c
new file mode 100644
index 0000000000000000000000000000000000000000..1b6791cf3d78a6261ea5a31e100810cc9b5b5e97
--- /dev/null
+++ b/roms/ipxe/src/core/lineconsole.c
@@ -0,0 +1,67 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Line-based console
+ *
+ */
+
+#include <stdint.h>
+#include <stddef.h>
+#include <ipxe/ansiesc.h>
+#include <ipxe/lineconsole.h>
+
+/**
+ * Print a character to a line-based console
+ *
+ * @v character		Character to be printed
+ * @ret print		Print line
+ */
+size_t line_putchar ( struct line_console *line, int character ) {
+
+	/* Strip ANSI escape sequences */
+	character = ansiesc_process ( &line->ctx, character );
+	if ( character < 0 )
+		return 0;
+
+	/* Ignore carriage return */
+	if ( character == '\r' )
+		return 0;
+
+	/* Treat newline as a terminator */
+	if ( character == '\n' )
+		character = 0;
+
+	/* Add character to buffer */
+	line->buffer[line->index++] = character;
+
+	/* Do nothing more unless we reach end-of-line (or end-of-buffer) */
+	if ( ( character != 0 ) &&
+	     ( line->index < ( line->len - 1 /* NUL */ ) ) ) {
+		return 0;
+	}
+
+	/* Reset to start of buffer */
+	line->index = 0;
+
+	return 1;
+}
diff --git a/roms/ipxe/src/core/list.c b/roms/ipxe/src/core/list.c
new file mode 100644
index 0000000000000000000000000000000000000000..77579d69aba9c0de31ecd214e8e9958a683daf9e
--- /dev/null
+++ b/roms/ipxe/src/core/list.c
@@ -0,0 +1,84 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Linked lists
+ *
+ */
+
+#include <ipxe/list.h>
+
+void extern_list_add ( struct list_head *new, struct list_head *head ) {
+	inline_list_add ( new, head );
+}
+
+void extern_list_add_tail ( struct list_head *new, struct list_head *head ) {
+	inline_list_add_tail ( new, head );
+}
+
+void extern_list_del ( struct list_head *list ) {
+	inline_list_del ( list );
+}
+
+int extern_list_empty ( const struct list_head *list ) {
+	return inline_list_empty ( list );
+}
+
+int extern_list_is_singular ( const struct list_head *list ) {
+	return inline_list_is_singular ( list );
+}
+
+int extern_list_is_last ( const struct list_head *list,
+			  const struct list_head *head ) {
+	return inline_list_is_last ( list, head );
+}
+
+void extern_list_cut_position ( struct list_head *new,
+				struct list_head *list,
+				struct list_head *entry ) {
+	inline_list_cut_position ( new, list, entry );
+}
+
+void extern_list_splice ( const struct list_head *list,
+			  struct list_head *entry ) {
+	inline_list_splice ( list, entry );
+}
+
+void extern_list_splice_tail ( const struct list_head *list,
+			       struct list_head *entry ) {
+	inline_list_splice_tail ( list, entry );
+}
+
+void extern_list_splice_init ( struct list_head *list,
+			       struct list_head *entry ) {
+	inline_list_splice_init ( list, entry );
+}
+
+void extern_list_splice_tail_init ( struct list_head *list,
+				    struct list_head *entry ) {
+	inline_list_splice_tail_init ( list, entry );
+}
+
+int extern_list_contains ( struct list_head *entry,
+			   struct list_head *head ) {
+	return inline_list_contains ( entry, head );
+}
diff --git a/roms/ipxe/src/core/log.c b/roms/ipxe/src/core/log.c
new file mode 100644
index 0000000000000000000000000000000000000000..f160b4fc8958ec4b270cf976e05b6f047dd0ac23
--- /dev/null
+++ b/roms/ipxe/src/core/log.c
@@ -0,0 +1,63 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * System logger
+ *
+ */
+
+#include <stdarg.h>
+#include <syslog.h>
+#include <ipxe/console.h>
+
+/**
+ * Write message to system log
+ *
+ * @v fmt		Format string
+ * @v args		Arguments
+ */
+void log_vprintf ( const char *fmt, va_list args ) {
+	int saved_usage;
+
+	/* Mark console as in use for log messages */
+	saved_usage = console_set_usage ( CONSOLE_USAGE_LOG );
+
+	/* Print message */
+	vprintf ( fmt, args );
+
+	/* Restore console usage */
+	console_set_usage ( saved_usage );
+}
+
+/**
+ * Write message to system log
+ *
+ * @v fmt		Format string
+ * @v ...		Arguments
+ */
+void log_printf ( const char *fmt, ... ) {
+	va_list args;
+
+	va_start ( args, fmt );
+	log_vprintf ( fmt, args );
+	va_end ( args );
+}
diff --git a/roms/ipxe/src/core/main.c b/roms/ipxe/src/core/main.c
index 9fd4a76ff8c075fed134f2536960..8ad912d43e8202456ac4a97a8287 100644
--- a/roms/ipxe/src/core/main.c
+++ b/roms/ipxe/src/core/main.c
@@ -14,53 +14,18 @@ Literature dealing with the network protocols:
 
 FILE_LICENCE ( GPL2_OR_LATER );
 
+#include <stddef.h>
 #include <stdio.h>
-#include <stdlib.h>
 #include <ipxe/init.h>
-#include <ipxe/features.h>
-#include <ipxe/shell.h>
-#include <ipxe/image.h>
-#include <ipxe/keys.h>
-#include <usr/prompt.h>
 #include <usr/autoboot.h>
 #include <config/general.h>
 
-#define NORMAL	"\033[0m"
-#define BOLD	"\033[1m"
-#define CYAN	"\033[36m"
-
-/** The "scriptlet" setting */
-struct setting scriptlet_setting __setting ( SETTING_MISC ) = {
-	.name = "scriptlet",
-	.description = "Boot scriptlet",
-	.tag = DHCP_EB_SCRIPTLET,
-	.type = &setting_type_string,
-};
-
-/**
- * Prompt for shell entry
- *
- * @ret	enter_shell		User wants to enter shell
- */
-static int shell_banner ( void ) {
-
-	/* Skip prompt if timeout is zero */
-	if ( BANNER_TIMEOUT <= 0 )
-		return 0;
-
-	return ( prompt ( "\nPress Ctrl-B for the iPXE command line...",
-			  ( BANNER_TIMEOUT * 100 ), CTRL_B ) == 0 );
-}
-
 /**
  * Main entry point
  *
  * @ret rc		Return status code
  */
 __asmcall int main ( void ) {
-	struct feature *feature;
-	struct image *image;
-	char *scriptlet;
 
 	/* Some devices take an unreasonably long time to initialise */
 	printf ( PRODUCT_SHORT_NAME " initialising devices..." );
@@ -68,49 +33,7 @@ __asmcall int main ( void ) {
 	startup();
 	printf ( "ok\n" );
 
-	/*
-	 * Print welcome banner
-	 *
-	 *
-	 * If you wish to brand this build of iPXE, please do so by
-	 * defining the string PRODUCT_NAME in config/general.h.
-	 *
-	 * While nothing in the GPL prevents you from removing all
-	 * references to iPXE or http://ipxe.org, we prefer you not to
-	 * do so.
-	 *
-	 */
-	printf ( NORMAL "\n\n" PRODUCT_NAME "\n" BOLD "iPXE " VERSION
-		 NORMAL " -- Open Source Network Boot Firmware -- "
-		 CYAN "http://ipxe.org" NORMAL "\n"
-		 "Features:" );
-	for_each_table_entry ( feature, FEATURES )
-		printf ( " %s", feature->name );
-	printf ( "\n" );
-
-	/* Boot system */
-	if ( ( image = first_image() ) != NULL ) {
-		/* We have an embedded image; execute it */
-		image_exec ( image );
-	} else if ( shell_banner() ) {
-		/* User wants shell; just give them a shell */
-		shell();
-	} else {
-		fetch_string_setting_copy ( NULL, &scriptlet_setting,
-					    &scriptlet );
-		if ( scriptlet ) {
-			/* User has defined a scriptlet; execute it */
-			system ( scriptlet );
-			free ( scriptlet );
-		} else {
-			/* Try booting.  If booting fails, offer the
-			 * user another chance to enter the shell.
-			 */
-			autoboot();
-			if ( shell_banner() )
-				shell();
-		}
-	}
+	ipxe ( NULL );
 
 	shutdown_exit();
 
diff --git a/roms/ipxe/src/core/malloc.c b/roms/ipxe/src/core/malloc.c
index d694f5559aabcc458e9c1367a3e3..56ca7edc625aedde6a4e44537b20 100644
--- a/roms/ipxe/src/core/malloc.c
+++ b/roms/ipxe/src/core/malloc.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -91,9 +92,9 @@ size_t freemem;
 /**
  * Heap size
  *
- * Currently fixed at 128kB.
+ * Currently fixed at 512kB.
  */
-#define HEAP_SIZE ( 128 * 1024 )
+#define HEAP_SIZE ( 512 * 1024 )
 
 /** The heap itself */
 static char heap[HEAP_SIZE] __attribute__ (( aligned ( __alignof__(void *) )));
@@ -105,11 +106,36 @@ static char heap[HEAP_SIZE] __attribute__ (( aligned ( __alignof__(void *) )));
 static inline void valgrind_make_blocks_defined ( void ) {
 	struct memory_block *block;
 
-	if ( RUNNING_ON_VALGRIND > 0 ) {
-		VALGRIND_MAKE_MEM_DEFINED ( &free_blocks,
-					    sizeof ( free_blocks ) );
-		list_for_each_entry ( block, &free_blocks, list )
-			VALGRIND_MAKE_MEM_DEFINED ( block, sizeof ( *block ) );
+	if ( RUNNING_ON_VALGRIND <= 0 )
+		return;
+
+	/* Traverse free block list, marking each block structure as
+	 * defined.  Some contortions are necessary to avoid errors
+	 * from list_check().
+	 */
+
+	/* Mark block list itself as defined */
+	VALGRIND_MAKE_MEM_DEFINED ( &free_blocks, sizeof ( free_blocks ) );
+
+	/* Mark areas accessed by list_check() as defined */
+	VALGRIND_MAKE_MEM_DEFINED ( &free_blocks.prev->next,
+				    sizeof ( free_blocks.prev->next ) );
+	VALGRIND_MAKE_MEM_DEFINED ( free_blocks.next,
+				    sizeof ( *free_blocks.next ) );
+	VALGRIND_MAKE_MEM_DEFINED ( &free_blocks.next->next->prev,
+				    sizeof ( free_blocks.next->next->prev ) );
+
+	/* Mark each block in list as defined */
+	list_for_each_entry ( block, &free_blocks, list ) {
+
+		/* Mark block as defined */
+		VALGRIND_MAKE_MEM_DEFINED ( block, sizeof ( *block ) );
+
+		/* Mark areas accessed by list_check() as defined */
+		VALGRIND_MAKE_MEM_DEFINED ( block->list.next,
+					    sizeof ( *block->list.next ) );
+		VALGRIND_MAKE_MEM_DEFINED ( &block->list.next->next->prev,
+				      sizeof ( block->list.next->next->prev ) );
 	}
 }
 
@@ -119,14 +145,45 @@ static inline void valgrind_make_blocks_defined ( void ) {
  */
 static inline void valgrind_make_blocks_noaccess ( void ) {
 	struct memory_block *block;
-	struct memory_block *tmp;
+	struct memory_block *prev = NULL;
+
+	if ( RUNNING_ON_VALGRIND <= 0 )
+		return;
+
+	/* Traverse free block list, marking each block structure as
+	 * inaccessible.  Some contortions are necessary to avoid
+	 * errors from list_check().
+	 */
+
+	/* Mark each block in list as inaccessible */
+	list_for_each_entry ( block, &free_blocks, list ) {
 
-	if ( RUNNING_ON_VALGRIND > 0 ) {
-		list_for_each_entry_safe ( block, tmp, &free_blocks, list )
-			VALGRIND_MAKE_MEM_NOACCESS ( block, sizeof ( *block ) );
-		VALGRIND_MAKE_MEM_NOACCESS ( &free_blocks,
-					     sizeof ( free_blocks ) );
+		/* Mark previous block (if any) as inaccessible. (Current
+		 * block will be accessed by list_check().)
+		 */
+		if ( prev )
+			VALGRIND_MAKE_MEM_NOACCESS ( prev, sizeof ( *prev ) );
+		prev = block;
+
+		/* At the end of the list, list_check() will end up
+		 * accessing the first list item.  Temporarily mark
+		 * this area as defined.
+		 */
+		VALGRIND_MAKE_MEM_DEFINED ( &free_blocks.next->prev,
+					    sizeof ( free_blocks.next->prev ) );
 	}
+	/* Mark last block (if any) as inaccessible */
+	if ( prev )
+		VALGRIND_MAKE_MEM_NOACCESS ( prev, sizeof ( *prev ) );
+
+	/* Mark as inaccessible the area that was temporarily marked
+	 * as defined to avoid errors from list_check().
+	 */
+	VALGRIND_MAKE_MEM_NOACCESS ( &free_blocks.next->prev,
+				     sizeof ( free_blocks.next->prev ) );
+
+	/* Mark block list itself as inaccessible */
+	VALGRIND_MAKE_MEM_NOACCESS ( &free_blocks, sizeof ( free_blocks ) );
 }
 
 /**
@@ -136,12 +193,26 @@ static inline void valgrind_make_blocks_noaccess ( void ) {
  */
 static unsigned int discard_cache ( void ) {
 	struct cache_discarder *discarder;
-	unsigned int discarded = 0;
+	unsigned int discarded;
 
 	for_each_table_entry ( discarder, CACHE_DISCARDERS ) {
-		discarded += discarder->discard();
+		discarded = discarder->discard();
+		if ( discarded )
+			return discarded;
 	}
-	return discarded;
+	return 0;
+}
+
+/**
+ * Discard all cached data
+ *
+ */
+static void discard_all_cache ( void ) {
+	unsigned int discarded;
+
+	do {
+		discarded = discard_cache();
+	} while ( discarded );
 }
 
 /**
@@ -149,6 +220,7 @@ static unsigned int discard_cache ( void ) {
  *
  * @v size		Requested size
  * @v align		Physical alignment
+ * @v offset		Offset from physical alignment
  * @ret ptr		Memory block, or NULL
  *
  * Allocates a memory block @b physically aligned as requested.  No
@@ -156,7 +228,7 @@ static unsigned int discard_cache ( void ) {
  *
  * @c align must be a power of two.  @c size may not be zero.
  */
-void * alloc_memblock ( size_t size, size_t align ) {
+void * alloc_memblock ( size_t size, size_t align, size_t offset ) {
 	struct memory_block *block;
 	size_t align_mask;
 	size_t pre_size;
@@ -173,12 +245,13 @@ void * alloc_memblock ( size_t size, size_t align ) {
 	size = ( size + MIN_MEMBLOCK_SIZE - 1 ) & ~( MIN_MEMBLOCK_SIZE - 1 );
 	align_mask = ( align - 1 ) | ( MIN_MEMBLOCK_SIZE - 1 );
 
-	DBG ( "Allocating %#zx (aligned %#zx)\n", size, align );
+	DBG ( "Allocating %#zx (aligned %#zx+%zx)\n", size, align, offset );
 	while ( 1 ) {
 		/* Search through blocks for the first one with enough space */
 		list_for_each_entry ( block, &free_blocks, list ) {
-			pre_size = ( - virt_to_phys ( block ) ) & align_mask;
-			post_size = block->size - pre_size - size;
+			pre_size = ( ( offset - virt_to_phys ( block ) )
+				     & align_mask );
+			post_size = ( block->size - pre_size - size );
 			if ( post_size >= 0 ) {
 				/* Split block into pre-block, block, and
 				 * post-block.  After this split, the "pre"
@@ -347,7 +420,7 @@ void * realloc ( void *old_ptr, size_t new_size ) {
 	if ( new_size ) {
 		new_total_size = ( new_size +
 				   offsetof ( struct autosized_block, data ) );
-		new_block = alloc_memblock ( new_total_size, 1 );
+		new_block = alloc_memblock ( new_total_size, 1, 0 );
 		if ( ! new_block )
 			return NULL;
 		VALGRIND_MAKE_MEM_UNDEFINED ( new_block, offsetof ( struct autosized_block, data ) );
@@ -458,6 +531,19 @@ struct init_fn heap_init_fn __init_fn ( INIT_EARLY ) = {
 	.initialise = init_heap,
 };
 
+/**
+ * Discard all cached data on shutdown
+ *
+ */
+static void shutdown_cache ( int booting __unused ) {
+	discard_all_cache();
+}
+
+/** Memory allocator shutdown function */
+struct startup_fn heap_startup_fn __startup_fn ( STARTUP_EARLY ) = {
+	.shutdown = shutdown_cache,
+};
+
 #if 0
 #include <stdio.h>
 /**
diff --git a/roms/ipxe/src/core/memblock.c b/roms/ipxe/src/core/memblock.c
new file mode 100644
index 0000000000000000000000000000000000000000..1fd89b871dcf485a0075ce2138d967da92495be6
--- /dev/null
+++ b/roms/ipxe/src/core/memblock.c
@@ -0,0 +1,81 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Largest memory block
+ *
+ */
+
+#include <stdint.h>
+#include <ipxe/uaccess.h>
+#include <ipxe/io.h>
+#include <ipxe/memblock.h>
+
+/**
+ * Find largest usable memory region
+ *
+ * @ret start		Start of region
+ * @ret len		Length of region
+ */
+size_t largest_memblock ( userptr_t *start ) {
+	struct memory_map memmap;
+	struct memory_region *region;
+	physaddr_t max = ~( ( physaddr_t ) 0 );
+	physaddr_t region_start;
+	physaddr_t region_end;
+	size_t region_len;
+	unsigned int i;
+	size_t len = 0;
+
+	/* Avoid returning uninitialised data on error */
+	*start = UNULL;
+
+	/* Scan through all memory regions */
+	get_memmap ( &memmap );
+	for ( i = 0 ; i < memmap.count ; i++ ) {
+		region = &memmap.regions[i];
+		DBG ( "Considering [%llx,%llx)\n", region->start, region->end );
+
+		/* Truncate block to maximum physical address */
+		if ( region->start > max ) {
+			DBG ( "...starts after maximum address %lx\n", max );
+			continue;
+		}
+		region_start = region->start;
+		if ( region->end > max ) {
+			DBG ( "...end truncated to maximum address %lx\n", max);
+			region_end = 0; /* =max, given the wraparound */
+		} else {
+			region_end = region->end;
+		}
+		region_len = ( region_end - region_start );
+
+		/* Use largest block */
+		if ( region_len > len ) {
+			DBG ( "...new best block found\n" );
+			*start = phys_to_user ( region_start );
+			len = region_len;
+		}
+	}
+
+	return len;
+}
diff --git a/roms/ipxe/src/core/menu.c b/roms/ipxe/src/core/menu.c
new file mode 100644
index 0000000000000000000000000000000000000000..8d42e1f835d588e35d89bc743baaa546fe34b84d
--- /dev/null
+++ b/roms/ipxe/src/core/menu.c
@@ -0,0 +1,178 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Menu selection
+ *
+ */
+
+#include <stdlib.h>
+#include <string.h>
+#include <assert.h>
+#include <ipxe/list.h>
+#include <ipxe/menu.h>
+
+/** List of all menus */
+static LIST_HEAD ( menus );
+
+/**
+ * Create menu
+ *
+ * @v name		Menu name, or NULL
+ * @v title		Menu title, or NULL
+ * @ret menu		Menu, or NULL on failure
+ */
+struct menu * create_menu ( const char *name, const char *title ) {
+	size_t name_len;
+	size_t title_len;
+	size_t len;
+	struct menu *menu;
+	char *name_copy;
+	char *title_copy;
+
+	/* Destroy any existing menu of this name */
+	menu = find_menu ( name );
+	if ( menu )
+		destroy_menu ( menu );
+
+	/* Use empty title if none given */
+	if ( ! title )
+		title = "";
+
+	/* Allocate menu */
+	name_len = ( name ? ( strlen ( name ) + 1 /* NUL */ ) : 0 );
+	title_len = ( strlen ( title ) + 1 /* NUL */ );
+	len = ( sizeof ( *menu ) + name_len + title_len );
+	menu = zalloc ( len );
+	if ( ! menu )
+		return NULL;
+	name_copy = ( ( void * ) ( menu + 1 ) );
+	title_copy = ( name_copy + name_len );
+
+	/* Initialise menu */
+	if ( name ) {
+		strcpy ( name_copy, name );
+		menu->name = name_copy;
+	}
+	strcpy ( title_copy, title );
+	menu->title = title_copy;
+	INIT_LIST_HEAD ( &menu->items );
+
+	/* Add to list of menus */
+	list_add_tail ( &menu->list, &menus );
+
+	DBGC ( menu, "MENU %s created with title \"%s\"\n",
+	       menu->name, menu->title );
+
+	return menu;
+}
+
+/**
+ * Add menu item
+ *
+ * @v menu		Menu
+ * @v label		Label, or NULL
+ * @v text		Text, or NULL
+ * @v shortcut		Shortcut key
+ * @v is_default	Item is the default item
+ * @ret item		Menu item, or NULL on failure
+ */
+struct menu_item * add_menu_item ( struct menu *menu, const char *label,
+				   const char *text, int shortcut,
+				   int is_default ) {
+	size_t label_len;
+	size_t text_len;
+	size_t len;
+	struct menu_item *item;
+	char *label_copy;
+	char *text_copy;
+
+	/* Use empty text if none given */
+	if ( ! text )
+		text = "";
+
+	/* Allocate item */
+	label_len = ( label ? ( strlen ( label ) + 1 /* NUL */ ) : 0 );
+	text_len = ( strlen ( text ) + 1 /* NUL */ );
+	len = ( sizeof ( *item ) + label_len + text_len );
+	item = zalloc ( len );
+	if ( ! item )
+		return NULL;
+	label_copy = ( ( void * ) ( item + 1 ) );
+	text_copy = ( label_copy + label_len );
+
+	/* Initialise item */
+	if ( label ) {
+		strcpy ( label_copy, label );
+		item->label = label_copy;
+	}
+	strcpy ( text_copy, text );
+	item->text = text_copy;
+	item->shortcut = shortcut;
+	item->is_default = is_default;
+
+	/* Add to list of items */
+	list_add_tail ( &item->list, &menu->items );
+
+	return item;
+}
+
+/**
+ * Destroy menu
+ *
+ * @v menu		Menu
+ */
+void destroy_menu ( struct menu *menu ) {
+	struct menu_item *item;
+	struct menu_item *tmp;
+
+	/* Remove from list of menus */
+	list_del ( &menu->list );
+
+	/* Free items */
+	list_for_each_entry_safe ( item, tmp, &menu->items, list ) {
+		list_del ( &item->list );
+		free ( item );
+	}
+
+	/* Free menu */
+	free ( menu );
+}
+
+/**
+ * Find menu
+ *
+ * @v name		Menu name, or NULL
+ * @ret menu		Menu, or NULL if not found
+ */
+struct menu * find_menu ( const char *name ) {
+	struct menu *menu;
+
+	list_for_each_entry ( menu, &menus, list ) {
+		if ( ( menu->name == name ) ||
+		     ( strcmp ( menu->name, name ) == 0 ) ) {
+			return menu;
+		}
+	}
+
+	return NULL;
+}
diff --git a/roms/ipxe/src/core/misc.c b/roms/ipxe/src/core/misc.c
index 8f56e1fb44ae5a54cc2aa6b0d4d6..11342481a73c12cfad1163d16d98 100644
--- a/roms/ipxe/src/core/misc.c
+++ b/roms/ipxe/src/core/misc.c
@@ -35,8 +35,17 @@ int inet_aton ( const char *cp, struct in_addr *inp ) {
 
 unsigned long strtoul ( const char *p, char **endp, int base ) {
 	unsigned long ret = 0;
+	int negative = 0;
 	unsigned int charval;
 
+	while ( isspace ( *p ) )
+		p++;
+
+	if ( *p == '-' ) {
+		negative = 1;
+		p++;
+	}
+
 	base = strtoul_base ( &p, base );
 
 	while ( 1 ) {
@@ -47,6 +56,9 @@ unsigned long strtoul ( const char *p, char **endp, int base ) {
 		p++;
 	}
 
+	if ( negative )
+		ret = -ret;
+
 	if ( endp )
 		*endp = ( char * ) p;
 
diff --git a/roms/ipxe/src/core/monojob.c b/roms/ipxe/src/core/monojob.c
index 7431f88a3a16333b3611784860dc..d262f70b25cd1268f9c0a0174112 100644
--- a/roms/ipxe/src/core/monojob.c
+++ b/roms/ipxe/src/core/monojob.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -53,37 +54,52 @@ struct interface monojob = INTF_INIT ( monojob_intf_desc );
 /**
  * Wait for single foreground job to complete
  *
- * @v string		Job description to display
+ * @v string		Job description to display, or NULL to be silent
  * @ret rc		Job final status code
  */
 int monojob_wait ( const char *string ) {
 	struct job_progress progress;
 	int key;
 	int rc;
+	unsigned long last_keycheck;
 	unsigned long last_progress;
+	unsigned long now;
 	unsigned long elapsed;
 	unsigned long completed;
 	unsigned long total;
 	unsigned int percentage;
 	int shown_percentage = 0;
 
-	printf ( "%s...", string );
+	if ( string )
+		printf ( "%s...", string );
 	monojob_rc = -EINPROGRESS;
-	last_progress = currticks();
+	last_keycheck = last_progress = currticks();
 	while ( monojob_rc == -EINPROGRESS ) {
+
+		/* Allow job to progress */
 		step();
-		if ( iskey() ) {
-			key = getchar();
-			switch ( key ) {
-			case CTRL_C:
-				monojob_close ( &monojob, -ECANCELED );
-				break;
-			default:
-				break;
+		now = currticks();
+
+		/* Check for keypresses.  This can be time-consuming,
+		 * so check only once per clock tick.
+		 */
+		if ( now != last_keycheck ) {
+			if ( iskey() ) {
+				key = getchar();
+				switch ( key ) {
+				case CTRL_C:
+					monojob_close ( &monojob, -ECANCELED );
+					break;
+				default:
+					break;
+				}
 			}
+			last_keycheck = now;
 		}
-		elapsed = ( currticks() - last_progress );
-		if ( elapsed >= TICKS_PER_SEC ) {
+
+		/* Display progress, if applicable */
+		elapsed = ( now - last_progress );
+		if ( string && ( elapsed >= TICKS_PER_SEC ) ) {
 			if ( shown_percentage )
 				printf ( "\b\b\b\b    \b\b\b\b" );
 			job_progress ( &monojob, &progress );
@@ -98,7 +114,7 @@ int monojob_wait ( const char *string ) {
 				printf ( "." );
 				shown_percentage = 0;
 			}
-			last_progress = currticks();
+			last_progress = now;
 		}
 	}
 	rc = monojob_rc;
@@ -106,10 +122,13 @@ int monojob_wait ( const char *string ) {
 	if ( shown_percentage )
 		printf ( "\b\b\b\b    \b\b\b\b" );
 
-	if ( rc ) {
-		printf ( " %s\n", strerror ( rc ) );
-	} else {
-		printf ( " ok\n" );
+	if ( string ) {
+		if ( rc ) {
+			printf ( " %s\n", strerror ( rc ) );
+		} else {
+			printf ( " ok\n" );
+		}
 	}
+
 	return rc;
 }
diff --git a/roms/ipxe/src/core/null_sanboot.c b/roms/ipxe/src/core/null_sanboot.c
index 9cdb16290487743ce77c3998fde3..18c0dea84ce4974ef8e708902c0d 100644
--- a/roms/ipxe/src/core/null_sanboot.c
+++ b/roms/ipxe/src/core/null_sanboot.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -38,6 +39,7 @@ static int null_san_describe ( unsigned int drive __unused ) {
 	return -EOPNOTSUPP;
 }
 
+PROVIDE_SANBOOT_INLINE ( null, san_default_drive );
 PROVIDE_SANBOOT ( null, san_hook, null_san_hook );
 PROVIDE_SANBOOT ( null, san_unhook, null_san_unhook );
 PROVIDE_SANBOOT ( null, san_boot, null_san_boot );
diff --git a/roms/ipxe/src/core/null_time.c b/roms/ipxe/src/core/null_time.c
new file mode 100644
index 0000000000000000000000000000000000000000..506c70b52aa5459e5f41edbdb893b15b970ea6d4
--- /dev/null
+++ b/roms/ipxe/src/core/null_time.c
@@ -0,0 +1,30 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Nonexistent time source
+ *
+ */
+
+#include <ipxe/time.h>
+
+PROVIDE_TIME_INLINE ( null, time_now );
diff --git a/roms/ipxe/src/core/nvo.c b/roms/ipxe/src/core/nvo.c
index ea58badef3e837c560802aaccaff..5383fe5c3681a052fef0538ecc30 100644
--- a/roms/ipxe/src/core/nvo.c
+++ b/roms/ipxe/src/core/nvo.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -191,8 +192,8 @@ static int nvo_save ( struct nvo_block *nvo ) {
  * @v setting		Setting
  * @ret applies		Setting applies within this settings block
  */
-static int nvo_applies ( struct settings *settings __unused,
-			 struct setting *setting ) {
+int nvo_applies ( struct settings *settings __unused,
+		  struct setting *setting ) {
 
 	return dhcpopt_applies ( setting->tag );
 }
@@ -295,7 +296,8 @@ int register_nvo ( struct nvo_block *nvo, struct settings *parent ) {
 		goto err_load;
 
 	/* Register settings */
-	if ( ( rc = register_settings ( &nvo->settings, parent, "nvo" ) ) != 0 )
+	if ( ( rc = register_settings ( &nvo->settings, parent,
+					NVO_SETTINGS_NAME ) ) != 0 )
 		goto err_register;
 
 	DBGC ( nvo, "NVO %p registered\n", nvo );
